#! /usr/bin/env python2.2
"""
***************************************************************************
    filename  : Job.py
    author    : Alessandro Maraschini
    email     : egee@datamat.it
    copyright : (C) 2003 by DATAMAT
***************************************************************************
//
// $Id: Job.py,v 1.8.2.4 2006/05/10 16:10:54 amarasch Exp $
//
"""
import os
import time
from threading import Thread
#import Thread
import socket
import UIutils
from UIutils import exit
from UIutils import errMsg
from glite_wmsui_AdWrapper import AdWrapper
from glite_wmsui_AdWrapper import DagWrapper
import random # for  TCP port range

"""
####################################
                         JobState Class
####################################
"""
class JobState:
  STATE_ID = "StateId"
  CURRENT_STEP="CurrentStep"
  USER_DATA="UserData"
  JOB_STEPS="JobSteps"
  GLITE_JOBID = "edg_jobid"
  state = ""
  """
  Initialise the JobState
  """
  def  __init__(self , state = ""):
    	self.state = AdWrapper( 1 )
  """
  Check the syntax of the State
  """
  def check (self):
	errors = ""
	s_id     = self.state.getStringValue (self.STATE_ID)
	# STATE_ID check
	if len(s_id) >1:
		errors+= self.STATE_ID +": List not allowed\n"
	elif len( s_id) ==1:
		jobid = JobId  ( s_id[0] )
		if not jobid.set:
			errors+= self.STATE_ID +": Wrong Id value\n"
	#  CURRENT_STEP check
	s_tep   = self.state.getStringValue (self.CURRENT_STEP)
	#  USER_DATA check
	u_data = self.state.getStringValue (self.USER_DATA)
	#  JOB_STEPS check
	j_steps = self.state.getStringValue (self.JOB_STEPS)
	if errors:
		UIutils.errMsg("Error","UI_JDL_ERROR", errors)
		exit(1)
  """
  Load a chkpt file
  """
  def fromFile( self ,stateFile ):
	if not os.path.isfile(   stateFile ):
			UIutils.errMsg("Error","UI_FILE_NOT_FOUND",submissionFile)
			exit(1)
	elif ( self.state.fromFile(stateFile) ):
			exit(1)
  """
  Generate a JobState from a string
  """
  def fromString(self, stateStr):
	#self.state.get_error() ;
	self.state.fromString( stateStr.strip() )
	err , apiMsg = self.state.get_error() ;
	if err:
		UIutils.errMsg("Error","UI_JDL_ERROR", "Unable to convert into a jobstate instance.\n"+ apiMsg )
		exit(1)
  """
  toString: convert the State instace into string representation
  """
  def toString( self, multi = 0):
	str = self.state.toLines()
	if not multi:
		str = str.replace ("\n" , " " )
	return str
  """
  Insert the dg_jobid (remove the previous if needed)
  """
  def setId( self, jobid):
	if self.state.hasKey(self.STATE_ID ):
		self.state.removeAttribute( self.STATE_ID )
	self.state.setAttributeStr ( self.STATE_ID , jobid )
  """
  Initialise default JobState from a ready-to-submit jobad
  """
  def initialise ( self, jobad ):
	if  jobad.hasKey ( self.GLITE_JOBID ):
			self.state.setAttributeStr (self.STATE_ID, jobad.getStringValue(self.GLITE_JOBID)[0])
	if  jobad.hasKey ( self.CURRENT_STEP ):
			self.state.setAttributeInt (self.CURRENT_STEP, jobad.getIntValue(self.CURRENT_STEP)[0])
	else:
		self.state.setAttributeInt(self.CURRENT_STEP, 1)
	self.state.setAttributeExpr ( self.USER_DATA , "[]" )
	#### JOB Steps special attribute managing
	if  jobad.hasKey (self.JOB_STEPS ):
			val = jobad.getStringValue (self.JOB_STEPS )
			if val:
				for va in val:
					self.state.addAttributeStr ( self.JOB_STEPS ,  va )
			else: #it's not a string. could be an int
				val =jobad.getIntValue (self.JOB_STEPS )
				if val:
					self.state.setAttributeInt ( self.JOB_STEPS ,  val[0] )
				else: #It's neither a string or an integer but it's present in the jdl: error
					UIutils.errMsg("Error","UI_JDL_ERROR", "Wrong type caught for " + self.JOB_STEPS  )

"""
####################################
                         JobId Class
####################################
"""
class JobId:
  lbHost = ""
  lbPort = 0
  unique = ""
  jobid = ""
  set = 0
  def  __init__(self, jobid=""):
     if jobid:
        self.fromString (jobid)
  #def  __init__(self):
  #   self.set= 0
  """
  create a jobId instance from string
  """
  def  fromString (self, jobid):
    LB_DEFAULT_PROTOCOL = "https://"
    avail_prots=["http","https"]
    output=[]
    if jobid:
     #extract information from jobid, using ':#' as token
     try: #cut http:# from the LB
        prot , body = jobid.split('://',1)
        if not prot in avail_prots:
                return 1
        prot= prot+"://"
        #separate address and  unique string
        lbAddr , unique = body.split('/',1)
        self.lbHost , self.lbPort = lbAddr.split (":" , 1 )
        self.lbPort = int (self.lbPort)
        if  not unique.strip():
               return 1
        self.unique=unique.strip()
        self.set = 1
        self.jobid = jobid

        return 0
     except:
        # display the error message
        return 3
     return 1
"""
  prompt the jobis to the user and let him select among them
  """
def selectJobId (jobid_list , multi = 1):
     if len(jobid_list) ==1:
        return jobid_list
     indJ = 0
     print "------------------------------------------------------------------"
     for jobus in jobid_list:
       indJ = indJ +1
       print repr(indJ).ljust(2) + ':', jobus.jobid
     if multi:
        print 'a'.ljust(2) + ':','all'
     print 'q'.ljust(2) + ':','quit'
     keep=1
     print "------------------------------------------------------------------"
     if multi:
        question= '\nChoose one or more jobId(s) in the list - [1-'+str(indJ)+']all:'
     else:
        question= '\nChoose one jobId in the list - [1-'+str(indJ)+']:'
     jobChoose = []
     while keep:
       ans=raw_input(question)
       ansSplit=ans.split(',')
       anslen = len(ansSplit)
       if (  ans.find(",")* ans.find("-") !=1 ) and not multi:
          keep = 1
       elif (ans==""):
         jobChoose = jobid_list
         keep =0
       elif (ans=="q"):
        print 'bye'
        UIutils.exit(0)
       elif (ans == "a"):
         if multi:
           keep = 0
           jobChoose = jobid_list
       else:
         if (anslen == 1):
           trat = ans.split('-')
           tratlen = len(trat)
           if (tratlen == 1):
             try:
              ind = int(ans)
              if ind in range(1,indJ+1):
               jobChoose.append(jobid_list[ind-1])
               keep=0
              else:
               jobChoose = []
               keep=1
             except:
              jobChoose = []
              keep = 1
           elif (tratlen == 2):
            try:
             s=int(trat[0])
             e=int(trat[1])
             ran = range(s,e+1)
             for k in ran:
              if k in range(1,indJ+1):
                 jobChoose.append(jobid_list[k-1])
                 keep = 0
              else:
                 jobChoose = []
                 keep = 1
            except:
               jobChoose = []
               keep = 1
           else:
             jobChoose = []
             keep = 1
         else:
           for h in ansSplit:
             trat = h.split('-')
             tratlen = len(trat)
             if (tratlen == 1):
              try:
               ind =int(h)
               if ind in range(1,indJ+1):
                jobChoose.append(jobid_list[ind-1])
                keep = 0
               else:
                jobChoose = []
                keep = 1
              except:
               jobChoose = []
               keep = 1
             elif (tratlen == 2):
              try:
               s=int(trat[0])
               e=int(trat[1])
               ran = range(s,e+1)
               for k in ran:
                if k in range(1,indJ+1):
                 jobChoose.append(jobid_list[k-1])
                 keep = 0
                else:
                 jobChoose = []
                 keep = 1
              except:
               jobChoose = []
               keep = 1
             else:
              jobChoose = []
              keep = 1
     if jobChoose:
       print "\n"
       return jobChoose
     else:
        #Unable to find any jobid in the input file
        errMsg(info.logFile,'Error','UI_BAD_INPUT_FILE')
        UIutils.exit(1)
"""
Read the specified input file and return a list containing the jobid (s)
"""
def getJobIdfromFile (inFile ):
     sys_exit = 0
     if not os.path.isfile(inFile):
        errMsg('Error','UI_FILE_NOT_FOUND',inFile)
        exit(1)
     else:
       try:
           f=open(inFile)
       except:
           errMsg('Error','UI_OPEN_ERR',inFile)
           exit(1)
       right_jobs =[]
       str_jobs =[]
       parsed = 0
       for job in f.readlines():
           parsed +=1
           job = job.strip ()
           if (  job.find ('#') != 0) and ( job.find('//') != 0) and (job!=""):
              jobid = JobId()
              if jobid.fromString(job):
                 UIutils.errMsg( 'Warning','UI_WRONG_JOBID_FORMAT',job)
                 sys_exit = -1
              else:
                 if job in str_jobs:
                   UIutils.errMsg( 'Warning','UI_JOBID_REPEAT',job)
                   sys_exit = -1
                 else:
                    right_jobs.append( jobid )
                    str_jobs .append (job)
       f.close
     if not parsed:
          UIutils.errMsg('Error','UI_NO_JOBID')
          exit(1)
     return [sys_exit , right_jobs ]
"""
   Retrieve JobId from a list of strings:
"""
def getJobIdfromList ( jobids):
     jobs= []
     for job in jobids:
       job= job.strip ()
       jobid = JobId ( job )
       if not jobid.set:
          errMsg('Warning','UI_WRONG_JOBID_FORMAT',job)
          pass
       else:
          if job in jobs:
             errMsg('Warning','UI_JOBID_REPEAT',job)
          else:
            jobs.append(jobid)
     return jobs

"""
###############################
  Shadow Class: used to implement listener activities
###############################
"""
class Shadow:
  pipeRoot = ""
  jobid = JobId()
  threadNoGui=""
  #listener = ""
  host = ""
  port = 0
  pid = 0
  refresh  = 1
  accum = ""
  pipe = ""
  pipeOut = ""
  pipeErr = ""
  pipeIn = ""
  barbatruc=""
  writing = 0
  # gui = 1  #Deprecated
  """
  # INitialise parameters
  """
  def set(self , jid):
    self.jobid = jid
    #self.listener = ls
  """
  Write the string into the inputStream
  """
  def write (self, txt):
    self.writing = 1
    if not self.barbatruc:
         self.barbatruc=open ( self.pipeRoot +".in" , "w")
    self.pipeIn = open ( self.pipeRoot +".in" , "w")
    if txt[-1]!="\n":
       txt+="\n"
    self.pipeIn.write (txt)
    self.pipeIn.close()
    self.writing  = 0

  """
  Read and empty the Error buffer
  """
  def emptyErr(self ):
     return  self.pipeErr.read( 1 )
  """
  Read and empty the Output buffer
  """
  def emptyOut(self ):
     if not self.pipeOut:
         self.pipeOut =  open ( self.pipeRoot +".out" )
     return  self.pipeOut.read( 1 )
  """
  get the name of the error pipe
  """
  def getPipeErr(self):
     return self.pipeRoot +".err"
  """
  get the name of the input pipe
  """
  def getPipeIn(self):
     return self.pipeRoot +".in"
  """
  get the name of the  output pipe
  """
  def getPipeOut(self):
      return self.pipeRoot +".out"
  """
  get the name of the local host
  """
  def getHost(self):
     return  self.host
  """
  get the value of the shadow pid
  """
  def getPid(self):
     return self.pid
  """
  get the value of the port which is listening to
  """
  def getPort(self):
      return self.port
  """
  Kill the shadow listener process
  """
  def kill (self):
	if self.pid != 0 :
		command = "kill -9 " + repr( self.pid )
		os.system(command);
  """
  Destroy the instance
  """
  def detach(self):
     if self.barbatruc:
          self.barbatruc.close()
     self.kill()
     for fi in [  self.getPipeErr()  ,  self.getPipeOut()  ,  self.getPipeIn()   ]:
        try:
           os.remove( fi  )
        except:
           pass

  def __call__ (self, command):
	try:
		os.system( command  )
	except KeyboardInterrupt :
		print "bye bye!!!"
		exit(0)

  """
  Check the destination path
  """
  def  checkRootPath(self):
	# Pipe Stream required
	rootDir  = UIutils.FILESEP + "tmp"
	rd = UIutils.solvePath( UIutils.info.confAd.getStringValue ("ListenerStorage")[0] )
	if rd:
		rootDir = rd
	if  not os.path.isdir( rootDir ):
		errMsg('Error','UI_DIR_NOT_FOUND', rootDir)
		exit(1)
	self.pipeRoot =  rootDir +UIutils.FILESEP + "listener-" + self.jobid.unique
	foundPrevious =0
	for fi in [ self.pipeRoot ,  self.getPipeErr() ,   self.getPipeOut() ,  self.getPipeIn() ]:
		if  os.path.exists( fi ):
			errMsg( 'Warning' , 'UI_FILE_EXISTS', fi )
			foundPrevious=1
	if foundPrevious:
		question = "A previous interactive session might still be active.\nDo you whish to proceed anyway?"
		answ=UIutils.questionYN(question)
		if not answ: #No answered
			print "bye"
			exit (0)


  """
  Launch the glite--wms-grid-console-shadow and retrieve host &port information
  """
  def console( self, port=0):
	shPath = UIutils.info.prefix + UIutils.FILESEP +"bin/"
	command =shPath + "glite-wms-grid-console-shadow"
	if  not os.path.isfile( command):
		errMsg('Error','UI_FILE_NOT_FOUND', command)
		exit(1)
	else:
	   command = os.path.abspath( command )
	# Kill the glite-wms-grid-console-shadow, if still running:
	self.kill ()
	arguments = ""

	#Check for opened ports interval due to a possible firewall
	fromPort = 0
	toPort= 0
	env=0
	try:
		env = os.environ["GLOBUS_TCP_PORT_RANGE"]
		#environment variable found
		for sep in [ " " , ":" , "-" , "," ]:
			ind = env.find(sep)
			if ind!=-1:
				try:
					fromPort , toPort = env.split (sep)
					fromPort = int(fromPort)
					toPort = int(toPort) +1
					break
				except:
					pass
		if not fromPort:
			errMsg('Warning',"UI_ENVIRONM_ERROR","GLOBUS_TCP_PORT_RANGE" ,"Unable to parse the value" )
	except:
		pass
	#This variable stores the number of port retrieval.
	#If GLOBUS_TCP_PORT_RANGE is used then UI automatically retry on all available ports before surrending
	retryPort = 1
	#This is the grid_console_shadow error code for an used port
	ALREADY_USED_PORT = 98
	if port:
		# If the port is forced then check the value immediately
		if fromPort and toPort:
			# Port range found at the end of the cycle
			if port<fromPort or port>toPort:
				errMsg('Error','JOB_ATTACH_PORT_RANGE', self.jobid.jobid,  port , env)
				exit(1)
		arguments += " -port " + repr (port)
	elif fromPort and toPort:
		#Port not specified but range found: select randomly a port between the allowed range
		RandomPort = fromPort + int(( toPort - fromPort)* random.random() )
		port = RandomPort
		arguments += " -port " + repr (port)
		retryPort = toPort - fromPort
	# Launch the glite-wms-grid-console-shadow with --logfile (background process)
	# log std in/out/error into named pipe

	for i in range (retryPort):
		arguments += " -log-to-file " + self.pipeRoot   +" &";
		os.system(command + " " + arguments )
		time.sleep(10)
		# get the pid and the port:
		errConsoleInfo = self.getConsoleInfo()
		#Check For Error and if necessary retry
		if errConsoleInfo == ALREADY_USED_PORT:
			if fromPort and toPort and UIutils.info.debug:
				errMsg('Warning', "UI_CAN_NOT_EXECUTE" , shPath +"glite-wms-grid-console-shadow", "Port " + repr(port) +" is already in use")
			if fromPort:
				port =  fromPort +   (port +1) % ( toPort - fromPort )
			arguments = " -port " + repr (port)
		elif errConsoleInfo:
			errMsg('Error', "UI_CAN_NOT_EXECUTE" , shPath +"glite-wms-grid-console-shadow","Command failed")
			exit(1)
		else:
			#No error found. Console successfully Started
			if fromPort and toPort and UIutils.info.debug:
				UIutils.print_message(UIutils.info.logFile,"Firewall range port found. listening port forced to: " +repr (port )  )
			break

	if errConsoleInfo:
			errMsg('Error', "UI_CAN_NOT_EXECUTE" , shPath +"glite-wms-grid-console-shadow","Unable to find any available port")
			exit(1)

  def join(self):
	while 1:
		try:
			time.sleep(2)
		except KeyboardInterrupt :
			print "bye"
			self.detach ()
			exit(0)
	exit(0)

  """
  Once the consloe listener has started, port and pid information
  have to be retrieved from the info named pipe
  """
  def getConsoleInfo(self):
	adStr = "";
	timeout= 0
	MAXTIMEOUT=3
	while 1:
	   try:
	      self.pipe=open (self.pipeRoot)
	      break
	   except:
	      timeout=timeout+1
	      time.sleep(1)
	      if timeout >MAXTIMEOUT :
		errMsg('Error', "UI_CAN_NOT_EXECUTE" , "glite-wms-grid-console-shadow","Timeout limit exceeded while reading info named pipe")
		exit(1)
	while 1:
	    adStr += self.pipe.read( 1 )
	    if  adStr.find("]") !=-1:
	        break ;

	os.remove(   self.pipeRoot )
	ad = AdWrapper ( 1 )
	adStr = adStr.strip()
	if ad.fromString(adStr.replace ("\n" , " " ) ):
	   errMsg('Error', "UI_CAN_NOT_EXECUTE" , "glite-wms-grid-console-shadow","Wrong info pipe stream found")
	   exit(1)
	if ad.hasKey("SHADOW_ERROR"):
		return ad.getIntValue("SHADOW_ERROR")[0];
	port = ad.getIntValue("PORT");
	# Set the Shadow private members
	## PORT
	if len(port) ==1:
	   self.port = port[0]
	else:
	   errMsg('Error', "UI_CAN_NOT_EXECUTE" , "glite-wms-grid-console-shadow", "Wrong retrieved port value")
	   exit(1)
	## PID
	pid  = ad.getIntValue("PID");
	if len(pid) ==1:
	   self.pid = pid[0]
	else:
	   errMsg('Error', "UI_CAN_NOT_EXECUTE" ,  "glite-wms-grid-console-shadow","Wrong retrieved pid value")
	   exit(1)
	## HOST
	self.host = socket.gethostbyaddr(socket.gethostname())[2][0]
	return 0

"""
###############################
   JobStatus Class
###############################
"""
class JobStatus:
	states= [ "Acl", "cancelReason", "cancelling","ce_node","children", \
	"children_hist","children_num","children_states","condorId","condor_jdl", \
	"cpuTime","destination", "done_code","exit_code","expectFrom", \
	"expectUpdate","globusId","jdl","jobId","jobtype", \
	"lastUpdateTime","localId","location", "matched_jdl","network_server", \
	"owner","parent_job", \
	"Payload_Running", "Possible_Ce_Nodes","Possible Destinations",\
	"reason","resubmitted","rsl","seed","stateEnterTime",\
	"stateEnterTimes","subjob_failed","user tags" , "status" , "status_code","hierarchy"]

	states_codes=[ "UNDEF","SUBMITTED","WAITING","READY", "SCHEDULED" ,"RUNNING","DONE" ,"CLEARED","ABORTED","CANCELLED","UNKNOWN","PURGED"]


	UNDEF = 0,
	SUBMITTED = 1
	WAITING =2
	READY= 3
	SCHEDULED= 4
	RUNNING= 5
	DONE= 6
	CLEARED= 7
	ABORTED= 8
	CANCELLED= 9
	UNKNOWN= 10
	PURGED= 11
	CODE_MAX= 12


	VECT_OFFSET = len(  states  )

	def  __init__(self ):
		self.sons=0
		self.jobidMap={}
		self.jdl=""
		self.DSTime = " "  +time.strftime("%Z")

	def printStatus(self,status, st , level):
		info = status.loadStatus ( st )
		# Map has to be initialised for each PrintStatus
		self.jobidMap={}
		self.level = level
		self.hierarchy = 0
		self.jobid =""
		intervals = int ( len(info) / self.VECT_OFFSET  )
		result =""
		for off in range ( intervals ):
			offset = off*self.VECT_OFFSET
			result +=self.printSt(  info[ offset : offset + self.VECT_OFFSET ] )
		return result

	def printSt( self, info ):
		hierarchy = int(info[self.states.index("hierarchy") ])
		indent = "    "*hierarchy
		stStr = ""
		adStr= ""
		sep = "*************************************************************\n" + indent
		jobid =info[ self.states.index("jobId")]
		if not indent:
			# Indentation is NOT present: main Job
			self.jobid =jobid
			Title= "\n" + indent+""+sep +  "BOOKKEEPING INFORMATION:\n"
			# initialize jdl
			self.jdl=info [ self.states.index("jdl") ]
		elif hierarchy > self.hierarchy:
			# Hierarchy increased: previous job was father
			Title = "\n"+ "    "*(hierarchy-1)+"- Nodes information:"
			if self.level>1:
				Title+= self.jobid+":\n"
			# Managing jobid-node mapping (when possible)
			if not self.jobidMap  and self.jdl:
				# jdl initialised, map still empty
				if self.jdl.strip().startswith("["):
					# JDL may not be a classad (bugfix #16727)
					dagad = DagWrapper()
					if dagad.fromString(self.jdl):
						err , apiMsg = dagad.get_error ()
						errMsg('Warning','UI_JDL_WRONG_SYNTAX' ,  apiMsg)
					else:
						vectMap=dagad.getMap()
						err , apiMsg = dagad.get_error ()
						if err:
							errMsg('Warning','UI_JDL_WRONG_SYNTAX' ,  apiMsg)
						else:
							for i in range(len(vectMap)/2):
								self.jobidMap[vectMap[i*2]] = vectMap[i*2+1]

		else:
			# Some Indentation Found: it's (not the first) children
			Title= ""
			self.jobid =jobid
		Title = Title + "\n" +indent+"Status info for the Job : " + jobid
		if self.jobidMap:
			if self.jobidMap.has_key(jobid):
				Title = Title + "\n" +indent+"Node Name: ".ljust(20) + self.jobidMap[jobid]
			else:
				errMsg('Warning','UI_SUBJOB_ERROR' , "Unable to find node id:"+jobid+"\ninside jdl of dag:\n"+self.jobid)
		
		s = info [ self.states.index("status") ]
		Title = Title + "\n" + indent+"Current Status:".ljust(20) + s
		#DONE_CODE check (only on Done )
		done_code_str = ""
		if s=="Done":
			done_code  = info[ self.states.index("done_code") ]
			exit_code    = info[ self.states.index("exit_code") ]
			#PARSING Done code and Exit Code
			try:
				done_code  = int ( done_code )
			except ValueError:
				done_code_str = "(Unable to retrieve  a valid done_code)"
			try:
				exit_code  = int ( exit_code )
			except ValueError:
				exit_code = 1
			if done_code== 2:
				done_code_str = "(Cancelled)"
			elif done_code== 1:
				done_code_str = "(Failed)"
			elif done_code== 0 :
				if exit_code==0:
					done_code_str = "(Success)"
				else:
					done_code_str = "(Exit Code !=0)"
			else:
				done_code_str = "(Unexpected done code: " + repr(done_code) +" )"
			if self.level:
				#Add exit code information
				done_code_str = done_code_str +"\n" + indent+"Exit code:".ljust(20) +  repr (exit_code)
		Title = Title + " " + done_code_str
		if self.level:
			reason =  info[ self.states.index(  "reason") ]
			if reason.strip():
				Title = Title +"\n" + indent+"Status Reason:".ljust(20) + reason
			dest =  info[ self.states.index(  "destination")]
			if dest.strip():
				Title = Title +"\n" + indent+"Destination:".ljust(20) +  dest
			submissionTime =  int    (info[ self.states.index("stateEnterTimes")].split(" ")[1].split("=")[1]   )
			Title = Title + "\n" + indent+"Submitted:".ljust(20) + time.asctime(time.localtime( submissionTime )  ) + self.DSTime
			if self.level>2 or hierarchy==0:
				parent = info[ self.states.index(  "parent_job")]
				if parent.strip():
					Title+= "\n" +indent + "Parent Job:".ljust(20) + parent
			#Separator between jdl attributes:
			colsep = "\n"+indent+"      "
		if self.level>1:
		    stStr = stStr + "\n" + indent+"---\n\n" + indent+""
		    for val in range (len (self.states)-3 ): #cutting last tree parameters: status, status code, hierarchy
			name = self.states[val]
			value = info[val].strip()
			if name and value:
				if name in ["jobId", "exit_code", "stateEnterTime", "reason", "parent_job"]:
					pass
				elif name == "condor_jdl":
					if self.level>2:
						value = colsep + value.replace ("\n" , colsep )
						adStr += "- "+ name.ljust(24) + "=    " + value +"\n" + indent+""
				elif name in ["children_hist"]:
					if self.level>2:
						value = value.replace( " " , "\n".ljust(6) + indent )
						adStr += "- "+ name.ljust(16) + "=   " + value[0] + "\n".ljust(6) + indent + value[1:] +"\n" + indent+""
				elif name == "stateEnterTimes":
					if self.level>2:
						values = value.split(" ")
						value = ""
						for val in values[1:-1]:
							nam, val = val.split("=")
							nam = nam.ljust(16)
							try:
								val = int (val)
							except:
								val = 0
							if val==0:
								val = "\t\t---"
							else:
								val = time.asctime(time.localtime( val  ) )+ self.DSTime
							value = value + colsep + nam + " : " + val
						adStr += "- " +name.ljust(16) + "=   " + value +"\n" + indent+""
				elif name in ["jdl" , "matched_jdl"]:
					if self.level>2:
						if value[0]=="[":
							#it's a classad
							jobad = AdWrapper (1)
							if jobad.fromString(value):
								err , apiMsg = jobad.get_error ()
								errMsg('Warning','UI_JDL_WRONG_SYNTAX' ,  apiMsg) ;
							value = jobad.toLines()
							value = colsep + value.replace ("\n" , colsep )
						adStr += "- " +name.ljust(16) + "=   " + value +"\n" + indent+""
				elif name in [ "lastUpdateTime"]:
					value = time.asctime(time.localtime(  int (value ) ) )+ self.DSTime
					stStr += "- "+ name.ljust(24) + "=    " + value +"\n" + indent+""
				elif name in ["rsl"]:
					if self.level>2:
						value = colsep + value.replace ("\n" , colsep )
						adStr += "- " +name.ljust(16) + "=   " + value +"\n" + indent+""
				else:
					stStr += "- "+ name.ljust(24) + "=    " + value +"\n" + indent+""
		if adStr:
			adStr = "---\n" + indent+"" +adStr
		stStr= Title + stStr +adStr
		self.hierarchy = hierarchy
		if self.level:
			stStr += "\n" +sep
		return stStr



"""
Event
"""
class Event:
  events = [ \
  "arrived", \
  "classad", "descr", "dest_host", "dest_id","dest_instance", \
  "dest_jobid", "dest_port" ,"destination","exit_code","from","from_host", \
  "from_instance",  "helper_name","helper_params","host","jdl", \
  "job","jobId", "jobstat" , "jobType","level","local_jobid",  \
  "name", "node","notifid","ns", "nsubjobs", "operation", "owner",\
  "parent",  "permission",  "Permission Type", "priority" ,"queue", \
  "reason",  "result", "retval","seed","seqcode", \
  "source",  "src_instance", "src_role","status_code","svc_host", \
  "svc_name",  "svc_port", "tag","timestamp","user", \
  "user id" ,  "user Id type", "value", "event"]

